// GuiDemo1Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "GuiDemo1.h"
#include "GuiDemo1Dlg.h"
#include <math.h>
#include "pci9018.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CGuiDemo1Dlg dialog




CGuiDemo1Dlg::CGuiDemo1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGuiDemo1Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGuiDemo1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CGuiDemo1Dlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_EMG_STOP, OnButtonEmgStop)
	ON_BN_CLICKED(IDC_BUTTON_SD_STOP, OnButtonSdStop)
	ON_BN_CLICKED(IDC_BUTTON_RUN, OnButtonRun)
	ON_CBN_EDITCHANGE(IDC_COMBO_AXIS, OnEditchangeComboAxis)
	ON_CBN_SELCHANGE(IDC_COMBO_AXIS, OnSelchangeComboAxis)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CGuiDemo1Dlg message handlers

BOOL CGuiDemo1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	int board_count = 0, board_id[16];
	int rc = 0, axis ;
	CString str;

	SetTimer(1, 50, NULL);
	rc = p9018_open(&board_count, board_id);
	if(0 != rc)
	{
		AfxMessageBox("Init failed");
		OnOK();
	}

	if(board_count < 1)
	{
		AfxMessageBox("Find No device");
		OnOK();
	}
	else
	{
		for(int i = 0; i < board_count; i ++)
		{
			for(int j = 0; j < 8; j ++)
			{
				axis = board_id[i] * 8 + j;
				str.Format(TEXT("%d"), axis);
				GetDlgComboBox(IDC_COMBO_AXIS)->AddString(str);
			}
		}

		GetDlgComboBox(IDC_COMBO_AXIS)->SetCurSel(0);

	}

	GetDlgItem(IDC_EDIT1)->SetWindowText(TEXT("1000.0"));
	GetDlgItem(IDC_EDIT2)->SetWindowText(TEXT("100000.0"));
	GetDlgItem(IDC_EDIT3)->SetWindowText(TEXT("500000.0"));
	GetDlgItem(IDC_EDIT4)->SetWindowText(TEXT("500000.0"));
	GetDlgItem(IDC_EDIT11)->SetWindowText(TEXT("10000"));	//distance

	m_axis = board_id[0]*8 + 0;	//ĬϵĿ

	SetDlgItemCheck(IDC_RADIO1, TRUE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGuiDemo1Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGuiDemo1Dlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGuiDemo1Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CGuiDemo1Dlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default

	//release resource
	p9018_close();

	CDialog::OnClose();
}

//
//	ʱصڲѯ˶пλá״̬Ϣ
//
void CGuiDemo1Dlg::OnTimer(UINT_PTR nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	unsigned int motion_status = 0, io_status = 0;
	int cmd_pos = 0, enc_pos = 0;
	double cur_vel = 0.0f;
	int rc = 0;
	CString str;

	if(1 == nIDEvent)
	{
		MOT_AXIS_STAT stat;
		rc = p9018_axis_get_status(m_axis, &stat);
		if(!rc)
		{
			SetDlgItemText(IDC_EDIT6, (stat.inpos == 0)? TEXT("Y"):TEXT("N"));

			str.Format(TEXT("%.1f"), stat.cmdVel);
			GetDlgItem(IDC_EDIT5)->SetWindowText(str);

			str.Format(TEXT("%d"), (int)stat.cmdPos);
			GetDlgItem(IDC_EDIT7)->SetWindowText(str);

			str.Format(TEXT("%d"), (int)stat.actPos);
			GetDlgItem(IDC_EDIT8)->SetWindowText(str);

			//PEL
			SetDlgItemText(IDC_EDIT9, stat.posHardLimit? TEXT("Y"):TEXT("N"));

			//mel
			SetDlgItemText(IDC_EDIT10, stat.negHardLimit? TEXT("Y"):TEXT("N"));

			//Home
			SetDlgItemText(IDC_EDIT12, stat.homeSwitch? TEXT("Y"):TEXT("N"));

			//fault
			SetDlgItemText(IDC_EDIT13, stat.fault? TEXT("Y"):TEXT("N"));
		}
	}
	CDialog::OnTimer(nIDEvent);
}

//ֹͣûмٹ
void CGuiDemo1Dlg::OnButtonEmgStop() 
{
	// TODO: Add your control notification handler code here
	int rc = 0;
	CString str;
}

//ֹͣмٹ
void CGuiDemo1Dlg::OnButtonSdStop() 
{
	// TODO: Add your control notification handler code here
	int rc = 0;
	CString str;

	rc = p9018_axis_abort(m_axis);
	if(rc)
	{
		str.Format("Stop axis fail, return code: %d", rc);
		AfxMessageBox(str);
	}
}

//ָ
void CGuiDemo1Dlg::OnButtonRun() 
{
	// TODO: Add your control notification handler code here
	CString str;
	double  start_vel, max_vel, acc, dec;
	int dist;
	int rc = 0;

	UpdateData(TRUE);

	GetDlgItem(IDC_EDIT1)->GetWindowText(str);
	start_vel = _tstof((LPCSTR) str);

	GetDlgItem(IDC_EDIT2)->GetWindowText(str);
	max_vel = _tstof((LPCSTR) str);

	GetDlgItem(IDC_EDIT3)->GetWindowText(str);
	acc  = _tstof((LPCSTR) str);

	GetDlgItem(IDC_EDIT4)->GetWindowText(str);
	dec  = _tstof((LPCSTR) str);

	GetDlgItem(IDC_EDIT11)->GetWindowText(str);	//distance
	dist  = _tstoi((LPCSTR) str);

	//˶
	p9018_axis_set_profile(m_axis, start_vel, max_vel, acc, dec, acc*1000.0);

	//λ˶, ꣬١
	if(GetDlgItemCheck(IDC_RADIO1))
	{
		rc = p9018_axis_abs_move(m_axis, dist);
	}

	//(ٶģʽ)
	else if(GetDlgItemCheck(IDC_RADIO2))
	{
		rc = p9018_axis_cont_move(m_axis, fabs(max_vel));
	}

	//(ٶģʽ)
	else if(GetDlgItemCheck(IDC_RADIO3))
	{
		rc = p9018_axis_cont_move(m_axis, -fabs(max_vel));
	}

	else if(GetDlgItemCheck(IDC_RADIO_AXIS_HOME_POS))
	{
		rc = p9018_axis_home(m_axis, fabs(max_vel), 0);
	}
	else
	{
		rc = p9018_axis_home(m_axis, -fabs(max_vel), 0);
	}

	if(rc)
	{
		str.Format("Drive axis fail, return code: %d", rc);
		AfxMessageBox(str);
	}
}

void CGuiDemo1Dlg::OnEditchangeComboAxis() 
{
	// TODO: Add your control notification handler code here
	int sel ;

	sel = GetDlgComboBox(IDC_COMBO_AXIS)->GetCurSel();
	if(sel < 0)
		return;

	m_axis = sel;
}

void CGuiDemo1Dlg::OnSelchangeComboAxis() 
{
	// TODO: Add your control notification handler code here
	int sel ;

	sel = GetDlgComboBox(IDC_COMBO_AXIS)->GetCurSel();
	if(sel < 0)
		return;

	m_axis = sel;
}
